function a_getCookie(name) 
{
	for (var i=0; i < audit_bites.length; i++) 
	{
		var nextbite = audit_bites[i].split("=");
		if (nextbite[0] == name)
			return unescape(nextbite[1]);
	}
	return null;
}

function a_setCookie(name, value) 
{
	if (value != null && value != "")
		document.cookie = name + "=" + escape(value) + "; expires=" + audit_expiry.toGMTString();
	audit_bites = document.cookie.split("; ");
}

function a_delCookie(name)
{
	document.cookie = name + "=null; expires=Fri, 31 Dec 1999 23:59:59 GMT;";
	audit_bites = document.cookie.split("; ");
}

function audit_init( b_on_line, wt, sz_product_guid, sz_product_id, sz_product_version, sz_generic_data )
{
	audit_bites = document.cookie.split("; ");
	audit_today = new Date();
	audit_expiry = new Date(audit_today.getTime() + 730 * 24 * 60 * 60 * 1000);
	o_check_time = new Date(audit_today.getTime() - 1 * 24 * 60 * 60 * 1000);
	sz_url = "http://play.wildtangent.com/launch.asp?";
	t_guid = null;
	b_reset_data = false;
	b_audit_time = true;
	l_count = 0;
	g_count = 0;
	start_time = 0;
	t_time = 0;
	wt_file = null;
	start_time = audit_today.getTime();

	var sz_temp = a_getCookie( "l_count" );
	if( sz_temp != null )
		l_count = parseInt( sz_temp );
	sz_temp = a_getCookie( "g_count" );
	if( sz_temp != null )
		g_count = parseInt( sz_temp );
	sz_temp = a_getCookie( "t_time" );
	if( sz_temp != null )
		t_time = parseFloat( sz_temp );
	l_count++;
	a_setCookie( "l_count", "" + l_count + "" );

	sz_temp = a_getCookie( "check_date" );
	if( sz_temp != null )
	{
		o_check_time = new Date( sz_temp );
	}
	if( (b_on_line == true) && (o_check_time < audit_today) )
	{
		t_guid = a_getCookie( "tracking_guid" );
		server_request( wt, sz_product_guid, sz_product_id, sz_product_version, sz_generic_data );
	}
	
	setTimeout( "audit_game_time()", 1000 )
}

function audit_game_time()
{
	if( b_audit_time == false )
		return;
	var end_time = new Date();
	t_time += ((end_time.getTime() - start_time) / 1000);
	start_time = end_time.getTime();
	a_setCookie( "t_time", ""+t_time+"" );
	setTimeout( "audit_game_time()", 30000 )
}


function server_request( wt, sz_product_guid, sz_product_id, sz_product_version, sz_generic_data )
{
	sz_url += "tver=1.0&";
	if( t_guid == null )
		sz_url += "uguid=&";
	else
		sz_url += "uguid=" + escape(t_guid) + "&";
	sz_url += "pguid=" + escape(sz_product_guid) + "&";
	sz_url += "pid=" + escape(sz_product_id) + "&";
	sz_url += "pver=" + escape(sz_product_version) + "&";
	sz_url += "lcount=" + escape(""+l_count+"") + "&";
	sz_url += "gcount=" + escape(""+g_count+"") + "&";
	sz_url += "ttime=" + escape(""+t_time+"") + "&";
	sz_url += "gdata=" + escape(sz_generic_data);
	wt.setErrorHandling(0);
	wt_file = wt.readFile( sz_url, 1 );
	setTimeout( "file_check()", 1000 );
}

function start_product()
{
	g_count++;
	a_setCookie( "g_count", "" + g_count + "" );
}

function audit_shutdown()
{
	b_audit_time = false;
}

function file_check()
{
	if( wt_file == null )  //the readFile failed
	{
		return;
	}
	if( wt_file.isLoaded() == false )  //wait for file to load
	{
		setTimeout( "file_check()", 1000 );
		return;
	}
	if( wt_file.status() != 0 )  //no server response
	{
		return;
	}
	/* parse response
	------format------
	line 0 = version;
	line 1 = user guid;
	line 2 = days to next checkin;
	line 3 = reset data;
	*/
	var a_response = new Array(4);
	for( var i = 0; i < 4; i++ )
		a_response[i] = wt_file.readLine();

	if( a_response[0] != "1.0" )  //is this data we expect?
		return;

	//update guid
	if( a_response[1] != null )
	{
		t_guid = a_response[1];
		a_setCookie( "tracking_guid", t_guid );
	}

	//update next check in time
	if( a_response[2] != null )
	{
		var n_days = parseInt( a_response[2] );
		o_check_time = new Date(audit_today.getTime() + n_days * 24 * 60 * 60 * 1000);
		a_setCookie( "check_date", o_check_time.toString() );
	}

	//reset data if requested
	if( a_response[3] != null )
	{
		var reset_data = parseInt(a_response[3] );
		if( reset_data != 0 )
		{
			l_count = 1;
			g_count = 0;
			t_time = 0;
			a_delCookie( "l_count" );
			a_delCookie( "g_count" );
			a_delCookie( "t_time" );
		}
	}
}
